/* generated using openapi-typescript-codegen -- do not edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { ResourceIn } from '../models/ResourceIn';
import type { ResourceOut } from '../models/ResourceOut';
import type { Status } from '../models/Status';
import type { UserSynchronizationRequestOut } from '../models/UserSynchronizationRequestOut';
import type { CancelablePromise } from '../core/CancelablePromise';
import { OpenAPI } from '../core/OpenAPI';
import { request as __request } from '../core/request';
export class ResourceService {
    /**
     * List resources
     * List all resources.
     *
     * Permission `resource:list` required.
     * @param maintainerId Filter for resource by maintainer. If current user is the same as maintainer ID, permission `resource:list` required, otherwise `resource:list_filter`.
     * @param versionStatus Which versions of the resource to include in the response. Permission `resource:list_filter` required if None or querying for non-public resources, otherwise only permission `resource:list` required.
     * @param nameSubstring Filter resources by a substring in their name.
     * @param _public Filter resources to by the public flag
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceListResources(
        maintainerId?: string,
        versionStatus?: Array<Status>,
        nameSubstring?: string,
        _public?: boolean,
    ): CancelablePromise<Array<ResourceOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources',
            query: {
                'maintainer_id': maintainerId,
                'version_status': versionStatus,
                'name_substring': nameSubstring,
                'public': _public,
            },
            errors: {
                400: `Error in request parameters`,
                401: `Not authenticated`,
                403: `Not authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Request a new resource
     * Request a new resources.
     *
     * Permission `resource:create` required.
     * @param requestBody
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceCreateResource(
        requestBody: ResourceIn,
    ): CancelablePromise<ResourceOut> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/resources',
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error in request parameters`,
                401: `Not authenticated`,
                403: `Not authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * List resource sync requests
     * List all resource sync requests.
     *
     * Permission `resource:sync` required.
     * @returns UserSynchronizationRequestOut Successful Response
     * @throws ApiError
     */
    public static resourceListSyncRequests(): CancelablePromise<Array<UserSynchronizationRequestOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/sync_requests',
            errors: {
                400: `Error in request parameters`,
                401: `Not authenticated`,
                403: `Not authorized`,
                404: `Entity not Found`,
            },
        });
    }
    /**
     * Get a resource
     * Get a specific resource.
     *
     * Permission `resource:read` required.
     * @param rid
     * @param versionStatus Which versions of the resource to include in the response. Permission `resource:read_any` required if None or querying for non-public resources, otherwise only permission `resource:read` required.
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceGetResource(
        rid: string,
        versionStatus?: Array<Status>,
    ): CancelablePromise<ResourceOut> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/{rid}',
            path: {
                'rid': rid,
            },
            query: {
                'version_status': versionStatus,
            },
            errors: {
                400: `Error in request parameters`,
                401: `Not authenticated`,
                403: `Not authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Delete a resource
     * Delete a resources.
     *
     * Permission `resource:delete` required.
     * @param rid
     * @returns void
     * @throws ApiError
     */
    public static resourceDeleteResource(
        rid: string,
    ): CancelablePromise<void> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/resources/{rid}',
            path: {
                'rid': rid,
            },
            errors: {
                400: `Error in request parameters`,
                401: `Not authenticated`,
                403: `Not authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
}
